/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ADCA荞ݏA̎̏̂߂̍ʊ֐܂݂܂B\n
//!  ADC͘AύX(Rs)ɐݒ肳Adgp܂\n
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#include "config.h"
#include "structs.h"
#include "main.h"

#ifdef __GNUC__
  #include "lib_mcu/adc/adc.h"
  #include "lib_mcu/adc/adc_drv.h"
#elif __ICCAVR__
  #include "adc.h"
  #include "adc_drv.h"
#else
  #error Current COMPILER not supported
#endif

//******************************************************************************
// ϐ
//******************************************************************************
// ADCԍ\
//! \brief ̎悵ްADC̏Ԃێ
volatile ADC_Status_t ADCS;

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief ADCp荞ݏٰ(ISR)
 *
 * ISRADCԍ\̂ɍ̎悵lۑǍADCd𑀍菇ł̎
 * قɍXV܂B\n
 * U菇ƁAADCS.Flagݒ肳AADCS.Haltݒ肳ĂȂ
 * 菇蒼܂BȂ΁AADC͋֎~܂B\n
 * dŏȉ̏ꍇAADCS.MainsFALSEɐݒ肳܂B
 * VREF = 2.56V
 * \note 菇̕\
 * <pre>
 * 菇|MUX5|MUX4:0| /߰ |//||荀|
 * ----+----+------+-----------+----------+----+--------+-------
 *  01 |  0 | 01001|  ADC0/PF0 |  / |10{| Vshunt-|Ȃ
 *     |    |      |  ADC1/PF1 |  / |10{| Vshunt+|Ȃ
 *     |    |      |           |          |    |        |
 *  02 |  0 | 00000|  ADC0/PF0 |ݸ | 1{| Vbatt  |Ȃ
 *     |    |      |           |          |    |        |
 *  03 |  1 | 00011| ADC11/PB4 |ݸ | 1{| NTC    |Ȃ
 *     |    |      |           |          |    |        |
 *  04 |  1 | 00100| ADC12/PB5 |ݸ | 1{| RID    |Ȃ
 *     |    |      |           |          |    |        |
 *  05 |  0 | 01001|  ADC0/PF0 |  / |10{| Vshunt-|Ȃ
 *     |    |      |  ADC1/PF1 |  / |10{| Vshunt+|Ȃ
 * </pre>
 *
 * \todo IIN(菇ł#7)͌Ďgp܂B
 *
 * \todo t͌Đݒ肳܂BIBAT̕t͑芴xŁA
 * ]ėLł͂܂BAd(ႦΓdrŉNꍇ)(PWM
 * `邩Ɉˑ)[dɗႦConstantCurrent()PWMo͂
 * ێLȓNȂƂĉ߂܂B
 * ͍}PWMُɋAA۸тُ͈ԂɂȂAǍ
 * ɂȂł傤B
 */

#ifdef __GNUC__
ISR(ADC_vect)
#else
#pragma vector = ADC_vect
__interrupt void ADC_ISR (void)
#endif
{
	static unsigned char avgIndex = 0;
	unsigned char i, Next;
	signed int  temp = 0;
	unsigned long temp_buffer;

	// ǂق炩ɈˑĕϊǍɎ菇ł̎قɐ؂ւ
	switch (ADCS.MUX){
		// MUX=$09ADC0/ADC1(PF0/PF1)=Vshunt
		case 0x01:
		case 0x05:
			// xȂŏ̍2ڂKv
			if(ADCS.MUX == 0x01)
			{
				Next=0x05;
			}
			else
			{
				// ɂ̏ꍇA-512`0`511:0x200`0x3ff,0x000,0x001`0x1FF
				if (ADC > 511) {
					// ̒l(dr[d)
					temp_buffer = (I_SCALE_1 * (1024 -ADC)) / I_SCALE_2;
					ADCS.IBAT = -(signed int)temp_buffer;

					// dɊւĂ͏ɐ
					ADCS.IBAT = 0;
				}
				else if (ADC > 0){
					// ̒l(drd)
					temp_buffer = (I_SCALE_1 * ADC) / I_SCALE_2;
					ADCS.IBAT = (signed int)temp_buffer;
				}
				else{
					ADCS.IBAT = 0;
				}

				// drd̍̎𕽋ωzɑ}(łÂ̎㏑)A
				// čČvZĕςۑ܂B͎菇̍ŏIϊŁÂ
				// ADC̊}Ď菇ĊJ܂B
				ADCS.discIBAT[(avgIndex++ & 0x03)] = ADCS.IBAT;
				for (i = 0; i < 4 ; i++) {
					temp += ADCS.discIBAT[i];
				}
				ADCS.avgIBAT = (temp / 4);
				Next=0x02;
				// ̑̂߂ɑd=0x00 (case 0x02)
				Clear_adc_mux();
			}
		break;

		// MUX=0x00ADC0(PF0)=VBAT
		case 0x02:
			temp_buffer = (VBAT_SCALE_1 * ADC )/VBAT_SCALE_2;
			ADCS.rawVBAT = (unsigned int)temp_buffer;
			ADCS.rawVBAT = ADCS.rawVBAT;
//			ADCS.VBAT = ADCS.rawVBAT;
			ADCS.VBAT = (ADCS.VBAT + ADCS.rawVBAT)>>1;

#if(TARGET_BOARD == MEGAU4EK)
			// VARTAdrƓĳgp邾
			ADCS.rawNTC = 671;
			ADCS.rawRID = 300;
			ADCS.Flag = TRUE;
			Next=0x01;
			// ̑̂߂ɑd=0x09 (case 0x01)
			Clear_adc_mux();
			Select_adc_channel(0x09);
#else
			Next=0x03;
			// ̑̂߂ɑd=0x23 (case 0x03)
			Clear_adc_mux();
			Select_adc_channel(0x23);
#endif
		break;

		// MUX=0x23ADC11(PB4)=NTC
		case 0x03:
#ifdef TRUSTFIRE
			ADCS.rawNTC = 671;		// TrustFiredrpADCu (26)
#else
			ADCS.rawNTC = ADC;
#endif
			Next=0x04;
			// ̑̂߂ɑd=0x24 (case 0x04)
			Clear_adc_mux();
			Select_adc_channel(0x24);
		break;

		// MUX=0x24ADC12(PB5)=RID
		case 0x04:
#ifdef TRUSTFIRE
			ADCS.rawRID = 300;		// TrustFiredrpADCu (550mA)
#else
			ADCS.rawRID = ADC;
#endif
			ADCS.Flag = TRUE;
			Next=0x01;

			// ̑̂߂ɑd=0x09 (case 0x01)
			Clear_adc_mux();
			Select_adc_channel(0x09);
		break;

		default:					// Nׂł͂܂(d)B
			Next=0x01;				// 菇̐擪ŊJn

			// ̑̂߂ɑd=0x09 (case 0x01)
			Clear_adc_mux();
			Select_adc_channel(0x09);
		break;
	}

	// d菇ł̎قɍXVAꂪ}ĂΗɕϊݒ
	ADCS.MUX = Next;

	// ~}ꂸAϊ񂪊ĂADCċ
	if (!(ADCS.Flag))
	{
		Start_conv();
	}
}


/*! \brief ADCϊ2̊SȎ񂪋N̂҂܂B
 *
 * ̊֐͎񊮗׸ނAĂꂪĂѐݒ肳̂҂܂B
 * ̌A͊֐OɂxJԂ܂B
 * 
 */
void ADC_Wait (void)
{
//	Enable_adc();						// ADC
	ADCS.Flag = FALSE;
	Start_conv();						// ϊJn
	do {									// ϊ҂
	} while (ADCS.Flag == FALSE);

//	Enable_adc();						// ADC
	ADCS.Flag = FALSE;
	Start_conv();						// ϊJn
	do {								// ϊ҂
	} while (ADCS.Flag == FALSE);

//	Disable_adc();						// (CPUԂp邽߂)ADC~
}

/*! \brief ADCƓ݂
 *
 * ̊֐ADCAϊ(Rs)ɏ܂B
 *
 */
void ADC_Init (void)
{
	unsigned char i;

#ifdef __GNUC__
	Disable_interrupt();
#else
	__disable_interrupt();
#endif	

	ADCS.Halt = FALSE;					// ADC̘As

	// ADC(PF0,PF1)`Ԑݒ(́Aٱߋ֎~)
	DDRF &= ~((1<<DDF1)|(1<<DDF0));
	PORTF &= ~((1<<PORTF1)|(1<<PORTF0));

	// DIDR0: PF1,PF0޼ٓ͊ɏՕ֎~(d͉P)
	DIDR0 |= ((1<<ADC1D)|(1<<ADC0D));

#if(TARGET_BOARD != MEGAU4EK)
	// PB5,PB4
	DDRB &= ~((1<<DDB5)|(1<<DDB4));
	PORTB &= ~((1<<PORTB5)|(1<<PORTB4));

	// DIDR2: PB5,PB4޼ٓ͊ɏՕ֎~(d͉P)
	DIDR2 |= ((1<<ADC12D)|(1<<ADC11D));
#endif

	// ADCؾ
	ADCS.Flag = FALSE;
	ADCS.MUX = 0x01;

	// Vshunt
	// dƂ2.56VAd=0x09I
	Clear_adc_mux();
	Enable_internal_vref();
	Select_adc_channel(0x09);

    Enable_adc_high_speed_mode();

#if(TARGET_BOARD == MEGAU4EK)
	// Ou7(1/128)ɐݒ16MHz/128=125kHz(max 200kHz)
	Set_adc_prescaler(7);
#else
	// Ou6(1/64)ɐݒ8MHz/64=125kHz(max 200kHz)
	Set_adc_prescaler(6);
#endif

	// ϓdrdƌʓǂݎ
	ADCS.avgIBAT = 0;
	for (i = 0; i < 4; i++) {
		ADCS.discIBAT[i] = 0;
	}
	// ADCISRċ
	Enable_adc_it();
	Enable_adc();

#ifdef __GNUC__
	Enable_interrupt();
#else
	__enable_interrupt();
#endif

	// ߂Oް̎񊮗𓾂
	ADC_Wait();
}
